//////////////////////////////////////////////////
//                                              //
// Coded by Darko Bondjerovic  ( Bondja )       //
//                                              //
//            verzija 1.1.    	         	//
//                                              //  
//                                              //
// Ako imate bilo kakve sugestije, ili nadjete  //
// bilo kakav bug.. 				//
//						//
//  ... ili koristite DELPHI...                 // 
//						//
//             email: bondjasan@gmail.com       //
//                                              //
//////////////////////////////////////////////////


unit uClickShockwaveFlash;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, OleCtrls,
  ShockwaveFlashObjects_TLB,
  Dialogs,
  Forms; //  KeysToShiftState()


type
  TClickShockwaveFlash = class(tshockwaveFlash)
  private
    { Private declarations }
    FOnDblClick: TNotifyEvent;
    FOnMouseDown: TMouseEvent;
    procedure DoMouseDown(var Message: TWMMouse; Button: TMouseButton;
      Shift: TShiftState);
  protected
    { Protected declarations }
    procedure DblClick; override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
  public
    { Public declarations }
    constructor Create( AOwner: TComponent); override;
    procedure WMLButtonDblClk(var Message: TWMLButtonDblClk); message WM_LBUTTONDBLCLK;
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
    procedure WMRButtonDown(var Message: TWMRButtonDown); message WM_RBUTTONDOWN;
  published
    { Published declarations }
    property OnMouseDown: TMouseEvent read FOnMouseDown write FOnMouseDown;
    property OnDblClick: TNotifyEvent read FOnDblClick write FOnDblClick;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('BondjaComponents', [TClickShockwaveFlash]);
end;

{ TClickShockwaveFlash }

constructor TClickShockwaveFlash.Create(AOwner: TComponent);
begin
  inherited;
  ControlStyle := [csCaptureMouse, csClickEvents, csSetCaption, csDoubleClicks];
end;

procedure TClickShockwaveFlash.DblClick;
begin
  if Assigned(FOnDblClick) then FOnDblClick(Self);
end;

procedure TClickShockwaveFlash.DoMouseDown(var Message: TWMMouse;
  Button: TMouseButton; Shift: TShiftState);
begin
  if not (csNoStdEvents in ControlStyle) then
    with Message do
      if (Width > 32768) or (Height > 32768) then
        with CalcCursorPos do
          MouseDown(Button, KeysToShiftState(Keys) + Shift, X, Y)
      else
        MouseDown(Button, KeysToShiftState(Keys) + Shift, Message.XPos, Message.YPos);
end;

procedure TClickShockwaveFlash.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Assigned(FOnMouseDown) then FOnMouseDown(Self, Button, Shift, X, Y);
end;

// double click
procedure TClickShockwaveFlash.WMLButtonDblClk( var Message: TWMLButtonDblClk);
begin
  SendCancelMode(Self);
  
  if csCaptureMouse in ControlStyle then MouseCapture := True;
  if csClickEvents in ControlStyle then DblClick;
  DoMouseDown(Message, mbLeft, [ssDouble]);
end;

// left button click
procedure TClickShockwaveFlash.WMLButtonDown(var Message: TWMLButtonDown);
begin
  SendCancelMode(Self);
  
  if csCaptureMouse in ControlStyle then MouseCapture := True;
  if (csClickEvents in ControlStyle) then
     ControlState := ControlState + [csClicked];
  DoMouseDown(Message, mbLeft, []);
end;

// right button click
procedure TClickShockwaveFlash.WMRButtonDown(var Message: TWMRButtonDown);
var
  ACurPos: TPoint;
begin
  If Assigned( self.PopupMenu) then
  begin
    // prikazi popup menu:
    windows.GetCursorPos( ACurPos);
    self.PopupMenu.Popup(ACurPos.X, ACurPos.Y);
  end else begin
    // ok, izvrsi noramalno DoMouseDown;
    Inherited;
  end;
end;


end.
